/*******************************************************************************
 *	@file			TCP.cpp
 *	@brief			Network Library
 *
 *	@author			ohwhsmm7
 *
 *	@date			30-Dec-2011(Fri)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "TCP.h"

/*******************************************************************************
 *	@namespace	NET
 ******************************************************************************/
namespace	NET
{

// O[oϐ-----------------------------------------------------------

// ֐vg^Cv錾-----------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				CTCP::AtteThread( void *p )
 *	@param[in]		p							ėp
 *	@retval			unsigned					TRUE
 *	@brief			FؗpXbh
 ******************************************************************************/
unsigned __stdcall CTCP::AtteThread( void *p )
{
	CTCP *pTCP = reinterpret_cast<CTCP*>( p );

	// TCP/IP\Pbg̍쐬
	SOCKET Srv;
	Srv = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );
	if( Srv == INVALID_SOCKET )
	{
		assert( 0 && "AtteThread : WSASocket()" );
		goto ERROR_THREAD;
	}

	// AhXݒ
	SOCKADDR_IN sa_in;
	sa_in.sin_family			= AF_INET;
	sa_in.sin_addr.S_un.S_addr	= ::inet_addr( pTCP->m_STcp.m_sAddr.c_str() );
	sa_in.sin_port				= ::htons( ::atoi( pTCP->m_STcp.m_sPort.c_str() ) );

	// 쐬\PbgɃAhXƃ|[g֘At
	if( ::bind( Srv, reinterpret_cast<SOCKADDR*>( &sa_in ), sizeof( SOCKADDR ) ) != 0 )
	{
		assert( 0 && "AtteThread : bind()" );
		goto ERROR_THREAD;
	}

	// TCPNCAg̐ڑv҂Ԃɐݒ
	if( ::listen( Srv, SOMAXCONN ) != 0 )
	{
		assert( 0 && "AtteThread : listen()" );
		goto ERROR_THREAD;
	}

	// [vŐڑv҂
	while( 1 )
	{
		SOCKET Socket;

		// ACCEPT
		// TCPNCAg̐ڑv󂯕t
		SOCKADDR_IN sa_out;
		int nLen = sizeof( SOCKADDR_IN );
		Socket = ::WSAAccept( Srv, reinterpret_cast<SOCKADDR*>( &sa_out ), &nLen, NULL, NULL );
		if( Socket == INVALID_SOCKET )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}
		if( SOCKET_ERROR == ::WSAGetLastError() )
		{
			assert( 0 && "AtteThread : WSAAccept()" );
			continue;
		}

		// ڑĂAhXg̏ꍇAIƂ݂Ȃ[vEo
		if( ::strcmp( pTCP->m_STcp.m_sAddr.c_str(), ::inet_ntoa( sa_out.sin_addr ) ) == 0 )
			break;

		// WSAAccept() őҋ@邽߂ԂsvǔÔ
		::Sleep( 1 );
	}

ERROR_THREAD:
	::closesocket( Srv );

	::_endthreadex( 0 );
	return TRUE;
}

/*******************************************************************************
 *	@fn				CTCP::CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CTCP::CTCP( void )
	: m_STcp()
	, m_nLogCnt( 0 )
{
#ifdef _DEBUG
	ClearLog();
	// e̐ݒAz񏉊
	m_vLog.reserve( LOG_MAX );
	m_vLog.assign( LOG_MAX, "" );
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				CTCP::~CTCP( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CTCP::~CTCP( void )
{
}

/*******************************************************************************
 *	@fn				void CTCP::CTCP( const STCP& STcp )
 *	@param[in]		STCP						\
 *	@retval			none						Ȃ
 *	@brief			ZbgAbv\̐ݒ
 ******************************************************************************/
void CTCP::SetTCP( const STCP& STcp )
{
	m_STcp = STcp;
}

/*******************************************************************************
 *	@fn				int CTCP::Init( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CTCP::Init( void )
{
	unsigned int uiID;
	HANDLE hID;

	// TCPT[o[gp
	if( m_STcp.m_bServer )
	{
		SetLog( "TCP/IP T[o[Jn" );
		hID = reinterpret_cast<HANDLE>( ::_beginthreadex( NULL, 0, &CTCP::AtteThread, this, 0, &uiID ) );
		::CloseHandle( hID );
	}
	// TCPNCAggp
	if( m_STcp.m_bClient )
	{
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				int CTCP::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 *					ׂẴXbhI
 ******************************************************************************/
int CTCP::End( void )
{
	// TCPT[o[gp
	if( m_STcp.m_bServer )
	{
		// őgݍ

		// TCP/IP\Pbg̍쐬
		SOCKET sock = ::WSASocket( AF_INET, SOCK_STREAM, IPPROTO_TCP, NULL, 0, 0 );

		// ڑwp\̂̏
		struct sockaddr_in sa_in;
		sa_in.sin_family			= AF_INET;
		sa_in.sin_addr.S_un.S_addr	= ::inet_addr( m_STcp.m_sAddr.c_str() );
		sa_in.sin_port				= ::htons( ::atoi( m_STcp.m_sPort.c_str() ) );

		// ɐڑ
		int nLen = sizeof( SOCKADDR_IN );
		int nRes = ::WSAConnect( sock, reinterpret_cast<struct sockaddr *>( &sa_in ), sizeof( sa_in ), NULL, NULL, NULL, NULL );

		// Ô߂Pbҋ@
		::Sleep( 1000 );

		// TCPZbV̏I
		::closesocket( sock );

		SetLog( "TCP/IP T[o[I" );
	}

	return TRUE;
}

/*******************************************************************************
 *	@fn				void CTCP::ClearLog( void )
 *	@retval			none						Ȃ
 *	@brief			ONA
 ******************************************************************************/
void CTCP::ClearLog( void )
{
#ifdef _DEBUG
	int nMax = m_vLog.size();
	for( int i = 0; i < nMax; i++ )
		m_vLog[ i ] = "";

	m_nLogCnt = 0;
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				void CTCP::SetLog( const char* cLog )
 *	@retval			none						Ȃ
 *	@brief			Oݒ
 ******************************************************************************/
void CTCP::SetLog( const char* cLog )
{
#ifdef _DEBUG
	int nCnt = m_nLogCnt % m_vLog.size();
	m_vLog[ nCnt ] = cLog;
	m_nLogCnt++;
#endif	// _DEBUG
}

/*******************************************************************************
 *	@fn				const string* CTCP::GetLog( const int& nNum )
 *	@param[in]		nNum						擾ԍ
 *	@retval			string*						ObZ[W
 *	@brief			O擾
 ******************************************************************************/
const std::string CTCP::GetLog( const int& nNum )
{
	std::string str;
#ifdef _DEBUG
	int nCnt = nNum % m_vLog.size();
	str = m_vLog[ nCnt ];
#endif	// _DEBUG
	return str;
}

}	// namespace	NET
