/*******************************************************************************
 *	@file			Net.h
 *	@brief			Network Test Program
 *
 *	@author			ohwhsmm7
 *
 *	@date			12-Nov-2011(Sat)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "Net.h"
#include "TCP.h"

#include <commctrl.h>
#pragma comment ( lib, "comctl32.lib" )
#include "resource.h"

#ifdef _DEBUG
#pragma comment ( lib, "Debug\\_NetLib.lib" )
#else	// _DEBUG
#pragma comment ( lib, "Release\\_NetLib.lib" )
#endif	// _DEBUG

// 񋓌^`-------------------------------------------------------------------

// \̒`-------------------------------------------------------------------

// O[oϐ-----------------------------------------------------------
NET::CTCP*				g_pTcp;

char					g_cAddr[ 256 ];
char					g_cPort[ 256 ];

int						g_nTCP = -1;
int						g_nTCPDlg = 0;
int						g_nTCPLogCnt = 0;

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcInit( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			ݒp_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcInit( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_INITDIALOG:
		{
			LPARAM lpIP = MAKEIPADDRESS( 192, 168, 11, 2 );
			::SendDlgItemMessage( hWnd, IDC_IPADDRESS1, IPM_SETADDRESS, 0, lpIP );
			::SetDlgItemText( hWnd, IDC_EDIT1, L"12345" );
			::SendDlgItemMessage( hWnd, IDC_RADIO1, BM_SETCHECK, BST_CHECKED, 0 );
		}
		break;
	case WM_COMMAND:
		switch( LOWORD( wParam ) )
		{
		case IDC_BUTTON1:
			{
				DWORD lpIP = 0;
				::SendDlgItemMessage( hWnd, IDC_IPADDRESS1, IPM_GETADDRESS, 0, reinterpret_cast<LPARAM>( &lpIP ) );
				::sprintf_s( g_cAddr, 256, "%d.%d.%d.%d",
							FIRST_IPADDRESS( lpIP ),
							SECOND_IPADDRESS( lpIP ),
							THIRD_IPADDRESS( lpIP ),
							FOURTH_IPADDRESS( lpIP ) );
				::GetDlgItemTextA( hWnd, IDC_EDIT1, g_cPort, 256 );
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO1, BM_GETCHECK, 0, 0 ) ) g_nTCP = 0;
				if( ::SendDlgItemMessage( hWnd, IDC_RADIO2, BM_GETCHECK, 0, 0 ) ) g_nTCP = 1;
			}
			::EndDialog( hWnd, TRUE );
			return TRUE;
		}
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				BOOL CALLBACK DlgProcTCPSrv( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
 *	@retval			LRESULT
 *	@brief			TCPT[o[p_CAOvV[W
 ******************************************************************************/
BOOL CALLBACK DlgProcTCPSrv( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	// O擾
	if( g_nTCPDlg )
	{
		int nCnt = g_pTcp->GetLogCnt();
		if( nCnt > g_nTCPLogCnt )
		{
			std::string str = g_pTcp->GetLog( g_nTCPLogCnt );
			char cBuf[ 256 ];
			::sprintf_s( cBuf, 256, "%s\n", str.c_str() );
			::SendDlgItemMessageA( hWnd, IDC_LIST1, LB_ADDSTRING, 0, reinterpret_cast<LPARAM>( cBuf ) );
			g_nTCPLogCnt++;
		}
	}

	switch( uMsg )
	{
	case WM_INITDIALOG:
		g_nTCPDlg = 1;
		break;
	case WM_CLOSE:
	case WM_DESTROY:
		::EndDialog( hWnd, FALSE );
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************************
 *	@fn				int WINAPI WinMain( HINSTANCE hInstance,
 *									    HINSTANCE hPrevInstance,
 *										LPSTR lpCmdLine,
 *										int nCmdShow )
 *	@param[in]		hInstance		CX^Xnh
 *	@param[in]		hPrevInstance	CX^Xnh
 *	@param[in]		lpCmdLine		
 *	@param[in]		nCmdShow		
 *	@retval			LRESULT			
 *	@brief			vON
 ******************************************************************************/
int WINAPI WinMain( HINSTANCE hInstance,
				    HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow )
{
	// ݒ
	if( ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_INIT ), NULL, reinterpret_cast<DLGPROC>( DlgProcInit ) ) )
	{
		// gpNX̐ݒƎ擾
		switch( g_nTCP )
		{
		case 0: g_pTcp = reinterpret_cast<NET::CTCP*>( NET::SetupTCP( TRUE, FALSE, 1, g_cAddr, g_cPort ) ); break;
		case 1: g_pTcp = reinterpret_cast<NET::CTCP*>( NET::SetupTCP( FALSE, TRUE, 1, g_cAddr, g_cPort ) ); break;
		}

		// Network ̏
		NET::Init();

		switch( g_nTCP )
		{
		case 0: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPSRV ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPSrv ) ); break;
		case 1: ::DialogBox( hInstance, MAKEINTRESOURCE( IDD_TCPSRV ), NULL, reinterpret_cast<DLGPROC>( DlgProcTCPSrv ) ); break;
		}

		// Network ̏I
		NET::End();
	}

    return EXIT_SUCCESS;
}
